﻿using System;
using System.Linq;
using CommonBehaviors.Actions;
using JetBrains.Annotations;
using LazyBoxer.Helpers;
using Styx;
using Styx.CommonBot;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Action = Styx.TreeSharp.Action;

namespace LazyBoxer.Behaviors
{
    static class DeathAndGhost
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit CT { get { return Me.CurrentTarget; } }
        private static readonly WoWPoint NoLocation = new WoWPoint(0,0,0);

        public static Composite CreateDeadBehavior()
        {
            return new PrioritySelector(

                new Decorator(ret => Me.IsDead && !Me.IsGhost, //&& ((Leader != null && (!Leader.IsAlive || Leader.WorldLocation.Distance(Me.WorldLocation) > 20)) || Setting.Instance.FollowLeader == "[None]"),  
                    new Sequence(

                        // Release our corpse
                        new Action(context => Log.Info("We're dead! Releasing corpse")),
                        new Action(context => Lua.DoString("RepopMe()"))

                        )),

                new Decorator(ret => Me.IsGhost && !Battlegrounds.IsInsideBattleground,
                    new PrioritySelector(

                        // Move to the location of our corpse
                        new Decorator(ret => Me.InstanceCorpseLocation != NoLocation, new Action(context => Navigator.MoveTo(Me.InstanceCorpseLocation))),
                        new Decorator(ret => Me.CorpsePoint != NoLocation && Me.WorldLocation.Distance(Me.CorpsePoint) > 15, new Action(context => Navigator.MoveTo(Me.CorpsePoint))),

                        // Retrieve our body
                        new Decorator(ret => FollowTheLeader.Leader != null && FollowTheLeader.Leader.IsAlive,
                            new Sequence(
                                new Action(context => Log.Info("Recovering our body")),
                                new Action(context => Lua.DoString("RetrieveCorpse()"))

                        ))



                    ))

                );
        }

    }
}
