﻿using CommonBehaviors.Actions;
using LazyBoxer.Helpers;
using Styx;
using Styx.CommonBot;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Action = Styx.TreeSharp.Action;

namespace LazyBoxer.Behaviors
{
    static class ForceAttack
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit CT { get { return Me.CurrentTarget; } }

        public static bool ForceAttacking { get; set; }

        public static Composite CreateForceAutoAttack()
        {
            return

                new PrioritySelector(

                    // Turn of force attacking if leader is not in combat. 
                // This variable is used in the follow behavior to prevent it overriding our movment.
                    new Decorator(ret => ForceAttacking,
                                  new Decorator(ret => Setting.Instance.ForceAutoAttack.OK() && (FollowTheLeader.Leader == null || !FollowTheLeader.Leader.Combat || Me.Combat),
                                      new Action(context => ForceAttacking = false)
                                      )
                        ),

                    // Force the character into combat. This should help some other CCs where they don't want to engage if they are not attacked directly
                    new Decorator(ret => Setting.Instance.ForceAutoAttack.OK() && !Me.Combat && FollowTheLeader.Leader != null && FollowTheLeader.Leader.GotTarget && FollowTheLeader.Leader.Combat && Me.GotTarget && (Helpers.Extensions.IsMeMeleeClass && !CT.IsWithinMeleeRange || !Helpers.Extensions.IsMeMeleeClass),// && !StyxWoW.Me.IsAutoAttacking && StyxWoW.Me.AutoRepeatingSpellId != 75),
                        new PrioritySelector(

                            // Melee
                            new Decorator(ret => Helpers.Extensions.IsMeMeleeClass && !CT.IsWithinMeleeRange,
                                          new Sequence(
                                              new DecoratorContinue(ret => !CT.IsWithinMeleeRange, // && !Me.IsMoving,
                                                new Sequence(
                                                    new Action(context => ForceAttacking = true),
                                                    new Action(context => TreeRoot.StatusText = "Forcing character into melee range"),
                //new Action(context => Log.Info("Forcing autoattack, moving into melee range",true)),
                                                    new Action(context => Navigator.MoveTo(WoWMovement.CalculatePointFrom(CT.WorldLocation, (float)0.5 * CT.MeleeRange())))
                                                    )),

                                              //Movement.CreateMoveToMeleeBehavior(true),

                                              new Action(delegate { Lua.DoString("StartAttack()"); }),
                                              new Action(context => Navigator.Clear())
                                              )),

                            // Face the target as ranged has been presenting a few initial combat bugs.
                            new Decorator(ret => !Helpers.Extensions.IsMeMeleeClass && !Me.IsSafelyFacing(CT) && !Me.IsMoving,
                                          new Action(context => CT.Face())
                                ),

                            // Ranged attackers just auto attack
                            new Decorator(ret => !Helpers.Extensions.IsMeMeleeClass && !Me.IsCasting && !Me.Combat,
                                          new Sequence(
                //new Action(context => Log.Info("Forcing autoattack, moving into caster range", true)),
                //new Action(context => Lua.DoString("StartAttack()")),
                                              new Action(context => Log.Info("Forcing CC into combat by casting the most basic spell")),
                                              new WaitContinue(5, ret => !Me.IsMoving, new ActionAlwaysSucceed()),

                                              //new Action(c => Me.IsMoving ? RunStatus.Running : RunStatus.Success),
                                              new Action(context =>
                                              {
                                                  switch (Me.Class)
                                                  {
                                                      case WoWClass.Priest:
                                                          SpellManager.Cast(Me.Specialization == WoWSpec.PriestShadow ? "Mind Blast" : "Smite");
                                                          break;

                                                      case WoWClass.Shaman:
                                                          SpellManager.Cast("Lightning Bolt");
                                                          break;

                                                      case WoWClass.Mage:
                                                          SpellManager.Cast("Frostfire Bolt");
                                                          break;

                                                      case WoWClass.Warlock:
                                                          SpellManager.Cast("Shadow Bolt");
                                                          break;

                                                      case WoWClass.Druid:
                                                          SpellManager.Cast("Wrath");
                                                          break;

                                                  }

                                              }),

                                                  // wait here for up to 5 seconds while casting a spell
                                              new Wait(5, ret => Me.IsCasting, new ActionAlwaysSucceed()),
                                              new Action(context => Navigator.Clear())
                                              ))

                            )
                        ));

        }
    }
}
