﻿using LazyBoxer.Helpers;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Action = Styx.TreeSharp.Action;

namespace LazyBoxer.Behaviors
{
    static class KeyToggles
    {
        //public static bool IsCombatAssistOnly = false;

        public static bool IsCombatAssistOnly
        {
            get { return Setting.Instance.AdvancedCombatAssist.OK(); }
       
            set
            {
                switch (value)
                {
                    case true:
                        Setting.Instance.AdvancedCombatAssist = "Enabled";
                        break;

                    case false:
                        Setting.Instance.AdvancedCombatAssist = "Disabled";
                        break;
                }
            }
        }

        

        private static bool _isCombatAssistKeyReleased = true;

        private static bool IsHotKeyPressed(string mainKeyPress, string modKeyPress)
        {
            if (mainKeyPress.Contains("None")) return false;

            if (modKeyPress.Contains("None"))
            {
                if (KeyboardPolling.IsKeyDown(FpswareLazyBoxer.KeyBinding(mainKeyPress))) return true;
            }
            else
            {
                if (KeyboardPolling.IsKeyDown(FpswareLazyBoxer.KeyBinding(mainKeyPress)) && KeyboardPolling.IsKeyDown(FpswareLazyBoxer.KeyBinding(modKeyPress))) return true;
            }

            return false;
        }

        public static Composite CreateGlobalKeyToggle()
        {
            return new PrioritySelector(

                // Released the key?
                new Decorator(ret => !_isCombatAssistKeyReleased, new Action(context => { if (!KeyboardPolling.IsKeyDown(FpswareLazyBoxer.KeyBinding(Setting.Instance.KeyCombatAssistOnly)))_isCombatAssistKeyReleased = true; })),

                // Combat Assist ONLY key toggle ON
                new Decorator(ret => _isCombatAssistKeyReleased && IsHotKeyPressed(Setting.Instance.KeyCombatAssistOnly, Setting.Instance.KeyCombatAssistOnlyMod),
                                  new Action(context =>
                                      {
                                          _isCombatAssistKeyReleased = false;
                                          IsCombatAssistOnly = !IsCombatAssistOnly;

                                          Lua.DoString(IsCombatAssistOnly
                                                           ? @"print('Combat Assist ONLY is \124cFF15E61C ENABLED!')"
                                                           : @"print('Combat Assist ONLY is \124cFFE61515 DISABLED!')");

                                          return RunStatus.Failure;
                                      })
                            )




            );
        }
    }
}
