﻿using CommonBehaviors.Actions;
using LazyBoxer.Helpers;
using Styx;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Action = Styx.TreeSharp.Action;

namespace LazyBoxer.Behaviors
{
    static class Vendoring
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit CT { get { return Me.CurrentTarget; } }

        public static bool SellingAtVendor { get; set; }

        public static Composite CreateVendorRepair()
        {
            return

                new PrioritySelector(

                    // turn off vendoring
                    new Decorator(ret => SellingAtVendor, new Action(context => { SellingAtVendor = false; })),

                    // Vendor if we need to repair
                    new Decorator(ret =>FollowTheLeader.Leader != null && FollowTheLeader.Leader.GotTarget &&FollowTheLeader.Leader.CurrentTarget.IsRepairMerchant &&Me.GetEstimatedRepairCost().TotalCoppers > 0,
                        new Sequence(

                            // Move to interact with vendor
                            new DecoratorContinue(ret => !FollowTheLeader.Leader.CurrentTarget.WithinInteractRange,
                                new Sequence(
                                    new Action(context => SellingAtVendor = true),
                                    new Action(context => Log.Info("Moving to repair vendor", true)),
                                    new Action(context =>Navigator.MoveTo(WoWMovement.CalculatePointFrom(FollowTheLeader.Leader.CurrentTarget.WorldLocation,(float) 0.70*FollowTheLeader.Leader.CurrentTarget.InteractRange)))
                                    )),

                            // Interact with vendor
                            new Decorator(ret =>FollowTheLeader.Leader.CurrentTarget.WithinInteractRange && (Me.GetEstimatedRepairCost().TotalCoppers > 0),
                                new Sequence(
                                    new Action(context => Log.Info("Interacting with repair vendor", true)),
                                    new Action(context => FollowTheLeader.Leader.CurrentTarget.Interact()),

                                    new WaitContinue(4, ret => false, new ActionAlwaysSucceed()),

                                    // repair from guild first, then from personal 
                                    new Action(context => Lua.DoString("RepairAllItems(1)")),
                                    new Action(context => Lua.DoString("RepairAllItems()")),
                                    new WaitContinue(2, ret => false, new ActionAlwaysSucceed()),
                                    new Action(context =>{if (Me.GetEstimatedRepairCost().TotalCoppers <= 0)SellingAtVendor = false;})
                                    
                                    ))

                            )
                        ));
        }
    }
}
