﻿//
// Credit where its due. Some parts of this botbase are taken from LazyRaider, RaidBot and CombatBot
// Some of the questing and events are taken from Multibox Suit released by tjhasty
// Credit to the original authors where due. 
//

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Threading;
using System.Windows.Forms;
using LazyBoxer.Behaviors;
using LazyBoxer.Helpers;
using LazyBoxer.UI;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.CommonBot.Profiles;
using Action = Styx.TreeSharp.Action;

namespace LazyBoxer
{
    class FpswareLazyBoxer : BotBase
    {
        #region Local declarations
        public static LocalPlayer Me { get { return StyxWoW.Me; } }
        public static WoWUnit CT { get { return Me.CurrentTarget; } }
        public static bool IsInGroup { get { return Me.GroupInfo.IsInRaid || Me.GroupInfo.IsInParty; } }
        public static IEnumerable<WoWPlayer> GroupMembers { get { return !Me.GroupInfo.IsInRaid ? Me.PartyMembers : Me.RaidMembers; } }
        public static IEnumerable<WoWPartyMember> GroupMemberInfos { get { return !Me.GroupInfo.IsInRaid ? Me.GroupInfo.PartyMembers : Me.GroupInfo.RaidMembers; } }

        public static bool PauseBotbase = false;
        private byte _oldTps;
        private Composite _root;
        private static PulseFlags _pulseFlags;
        private readonly Version _version = new Version(0, 1, 1);

        // Navigation place holders
        private static INavigationProvider _preNavigationProvider;
        private static IPlayerMover _prePlayerMoverHandler;
        private static IStuckHandler _prevStuckHandler;
        private static NoStuckHandling pNoStuckHandling = new NoStuckHandling();

        private static WoWUnit Leader { get { return FollowTheLeader.Leader; } }

        #endregion

        #region Overrides

        public override PulseFlags PulseFlags { get { return _pulseFlags; } }
        public override string Name {get { return string.Format("Fpsware's LazyBoxer"); }}
        public override Composite Root { get { return _root ?? (_root = new PrioritySelector(CreateRootBehavior())); } }
        private UIForm _frm;
        public override Form ConfigurationForm { get { if (_frm == null || !_frm.Visible) _frm = new UIForm();  return _frm; } }

        #endregion

        #region Composites

        private Composite CreateRootBehavior()
        {
            return
                new PrioritySelector(

                    // botbase paused then do nothing
                    new Decorator(ret => PauseBotbase, new Action(ret => RunStatus.Success)),

                    // Did we press the key binding for Combat Assist only mode?
                    KeyToggles.CreateGlobalKeyToggle(),

                    // Release and repop
                    new Decorator(ret => Me.IsDead || Me.IsGhost, DeathAndGhost.CreateDeadBehavior()),

                    // Dead, ghost then do nothing
                    new Decorator(ret => !Me.IsAlive || Me.IsGhost, new Action(ret => RunStatus.Success)),
                    
                    // Not in combat behavior, Pre combat buffs and Resting etc
                    new Decorator(ret => !Me.Combat, CreateNotInCombatBehavior()),

                    // IN combat behavior
                    new Decorator(ret => Me.Combat, CreateCombatBehavior()),

                    // Follow the leader
                    FollowTheLeader.CreateFollowTheLeaderBehaviorsWithSanityChecks(),

                    new Action(context =>
                        {
                            if (!Me.Combat && !Me.IsMoving)
                            TreeRoot.StatusText = "";
                        })

            );
        }

        #region In combat behavior
        private Composite CreateCombatBehavior()
        {
            return
                new PrioritySelector(

                    // Find a target if we need one. Applies to DPS and Tanks
                    CreateFindATargetBehavior(),

                    // Heal
                    RoutineManager.Current.HealBehavior,

                    // Combat Buff and Combat Behavior
                    new Decorator(ret => Me.GotTarget && CT.Attackable && !CT.IsDead,
                                  new PrioritySelector(

                                      // Combat buffs by the CC
                                      RoutineManager.Current.CombatBuffBehavior,

                                      // Move to target and face 
                                      MoveAndFaceTarget.CreateCombatMovementAndFaceTarget(),

                                      // Auto attack for melee classes
                                      new Decorator(ret =>!StyxWoW.Me.IsAutoAttacking && StyxWoW.Me.AutoRepeatingSpellId != 75 && CT.IsWithinMeleeRange && Helpers.Extensions.IsMeMeleeClass,
                                          new Action(delegate{Lua.DoString("StartAttack()");return RunStatus.Failure;})),
                                    
                                       // Update HB status message with combat
                                       new Action(context => { TreeRoot.StatusText = "Combat with " + CT.Name; return RunStatus.Failure; }),

                                      // Perform the CC combat behavior
                                      RoutineManager.Current.CombatBehavior

                                      )));
        }
        private Composite CreateFindATargetBehavior()
        {
            return

                new PrioritySelector(
                
                    // Find a target if we need one
                    new Decorator(ret => Setting.Instance.Targeting.Contains("Assist") && Leader != null && Leader.GotTarget && Leader.Combat && (!Me.GotTarget || Me.GotTarget && CT.IsDead || Me.GotTarget && !CT.IsValidTarget() || Me.GotTarget && CT.Guid != Leader.CurrentTarget.Guid),
                                    new Sequence(
                                        new Action(context => Leader.CurrentTarget.Target()),
                                        //new LogMessage(string.Format("Assisting {0} with {1}", Leader.Name, Leader.CurrentTarget.Name))
                                        new Action(context => Log.Info(string.Format("Assisting {0} with {1}", Leader.Name, Leader.CurrentTarget.Name), true))
                                        )
                        ),
                                
                        // Dismount
                        new Decorator(ret=> Me.Mounted && !Me.IsFlying,
                            Common.Dismount()
                                        //new Action(context => Common.WaitForDismount())
                            ),

                        // Find a target if we need one
                        new ThrottlePasses(TimeSpan.FromMilliseconds(400),
                            new Decorator(ret => Setting.Instance.Targeting.Contains("Closest") && (!Me.GotTarget || Me.GotTarget && CT.IsDead || !CT.IsValidTarget()) && Units.AttackableUnits.FirstOrDefault() != null,
                                            new Sequence(
                                                new Action(context => Units.AttackableUnits.OrderBy(u=>u.Distance).FirstOrDefault().Target()),
                                                new Action(context => Log.Info(string.Format("Finding closest mob")))
                                                )
                            )),

                            // Find a target if we need one
                        new ThrottlePasses(TimeSpan.FromMilliseconds(400),
                            new Decorator(ret => Setting.Instance.Targeting.Contains("Lowest Threat") && (!Me.GotTarget || Me.GotTarget && CT.IsDead || !CT.IsValidTarget()) && Units.AttackableUnits.FirstOrDefault() != null,
                                            new Sequence(
                                                new Action(context =>
                                                    {
                                                        WoWUnit target = null;
                                                        int lowestThreat = 5000000;

                                                        List<WoWPlayer> members = StyxWoW.Me.GroupInfo.IsInRaid ? StyxWoW.Me.RaidMembers : StyxWoW.Me.PartyMembers;
                                                        foreach (WoWUnit attackableUnit in Units.AttackableUnits)
                                                        {
                                                            int aggroDifference = GetAggroDifferenceFor(attackableUnit, members);
                                                            if (aggroDifference > lowestThreat) continue;

                                                            lowestThreat = aggroDifference;
                                                            target = attackableUnit;
                                                        }

                                                        if (target != null) target.Target();
                                                    }),
                                                new Action(context => Log.Info(string.Format("Finding lowest threat mob")))
                                                )
                            )));
        }


        #endregion

        #region Out of combat behavior
        private Composite CreateNotInCombatBehavior()
        {
            return
                new Decorator(ret => !Me.Combat,
                    new PrioritySelector(

                        // If our leader has a target then assist them
                        new Decorator(ret => Setting.Instance.Targeting.Contains("Assist") && Leader != null && Leader.GotTarget && Leader.Combat && (!Me.GotTarget || Me.GotTarget && CT.IsDead || Me.GotTarget && !CT.IsValidTarget() || Me.GotTarget && Leader.GotTarget && Leader.CurrentTargetGuid != CT.Guid),
                            new Sequence(
                                new Action(context => Leader.CurrentTarget.Target()),
                                new Action(context => Log.Info(string.Format("Assisting {0} with {1}", Leader.Name, Leader.CurrentTarget.Name), true)),
                                new Action(context => !Me.GotTarget ? RunStatus.Running : RunStatus.Success),
                                new Action(context => { if (!Me.IsMoving) CT.Face(); })
                                )
                            ),
                            
                        // Pre combat buffs by the CC
                        new Decorator(ret => Me.GotTarget && CT.IsAlive && CT.IsValidTarget(), RoutineManager.Current.PreCombatBuffBehavior),

                        // Pull logic by the CC
                        new Decorator(ret => Leader != null && Leader.GotTarget && Leader.Combat && Leader.CurrentTarget.IsValidTarget(), RoutineManager.Current.PullBehavior),
                        

                        // Rest eat/drink by the CC
                        new PrioritySelector(RoutineManager.Current.RestBehavior),

                        // Force auto attack and move into range
                        ForceAttack.CreateForceAutoAttack(),

                        // Do vendor repairs 
                        new Decorator(ret=> !KeyToggles.IsCombatAssistOnly, Vendoring.CreateVendorRepair()),

                        // Loot
                        new Decorator(ret=> !KeyToggles.IsCombatAssistOnly, Looting.CreateLootingBehavior()),
                        
                        // Do questing stuff
                        new Decorator(ret=> !KeyToggles.IsCombatAssistOnly, Questing.CreateQuestPickupOrTurninBehavior()),

                        // Herbalism
                        new Decorator(ret=> !KeyToggles.IsCombatAssistOnly, Herbalism.CreateHerbHarvesting()),

                        // Mining
                        new Decorator(ret=> !KeyToggles.IsCombatAssistOnly, Mining.CreateOreHarvesting()),

                        // Search for skinnable mobs
                        new Decorator(ret=> !KeyToggles.IsCombatAssistOnly, Skinning.CreateSkinning()),

                        // Pickup quest objects
                        new Decorator(ret=> !KeyToggles.IsCombatAssistOnly, InteractableObjects.CreateQuestObjectInteraction()),

                        // FETCH ALLLLLL quests ... also turn in ALLLLL quests
                        new Decorator(ret => Setting.Instance.QuestFETCH.Contains("FETCH") && !KeyToggles.IsCombatAssistOnly, Questing.CreateQuestFetch())
                        
                            


                        ));
        }


        


        

        

        

        
        
        #endregion


        #endregion

        #region Threat difference (from Singular)
        private static int GetAggroDifferenceFor(WoWUnit unit, IEnumerable<WoWPlayer> partyMembers)
        {
            uint myThreat = unit.ThreatInfo.ThreatValue;
            uint highestParty = (from p in partyMembers
                                 let tVal = unit.GetThreatInfoFor(p).ThreatValue
                                 orderby tVal descending
                                 select tVal).FirstOrDefault();

            int result = (int)myThreat - (int)highestParty;
            return result;
        }
        #endregion
        
        #region Botbase Start, Stop and Initialise

        public override void Start()
        {
            _root = null;

            Navigator.PathPrecision = 1;

            Lua.Events.AttachEvent("PARTY_MEMBERS_CHANGED", HandlePartyMembersChanged);
            BotEvents.Player.OnMapChanged += Player_OnMapChanged;


            QuestingAndInteraction.AttachQuestingEvents();

            Lua.Events.AttachEvent("START_LOOT_ROLL", HandleLootRoll);
            Lua.Events.AttachEvent("CONFIRM_LOOT_ROLL", HandleConfirmLootRoll);
            Lua.Events.AttachEvent("CONFIRM_DISENCHANT_ROLL", HandleConfirmLootRoll);

            Lua.Events.AttachEvent("PARTY_INVITE_REQUEST", OnPartyInvite);
            Lua.Events.AttachEvent("LFG_ROLE_CHECK_SHOW", OnLfgRoleCheck);
            Lua.Events.AttachEvent("LFG_PROPOSAL_SHOW", OnLfgProposalShow);
            Lua.Events.AttachEvent("RESURRECT_REQUEST", OnRecurrectionHandler);
            Lua.Events.AttachEvent("READY_CHECK", OnReadyCheckHandler);

            // Set the number of ticks per second the botbase will function at
            _oldTps = TreeRoot.TicksPerSecond;
            TreeRoot.TicksPerSecond = (byte)Setting.Instance.TicksPerSecond;
            

            // Say who the leader is
            if (Leader != null)
            {
                Log.Info("Leader set to " + Leader.Name);
            }

            // Register chat events
            if (Setting.Instance.AllowCommands.Contains("Always"))
            {
                Log.Info("Registering chat commands");
                //Lua.Events.AttachEvent("CHAT_MSG_PARTY", Handler);
                //Lua.Events.AttachEvent("CHAT_MSG_SAY", Handler);
                //Lua.Events.AttachEvent("CHAT_MSG_WHISPER", Handler);
                //Lua.Events.AttachEvent("CHAT_MSG_RAID", Handler);
                
                Chat.Say += NewCommand;
                Chat.Party += NewCommand;
                Chat.Whisper += NewCommand;
                Chat.Raid += NewCommand;
            }

            // Tell HB what it can and cannot pulse
            _pulseFlags = PulseFlags.Objects | PulseFlags.Lua | PulseFlags.InfoPanel | PulseFlags.Targeting;
            //_pulseFlags = PulseFlags.Lua | PulseFlags.InfoPanel;

            if (Setting.Instance.Plugins.OK())
            {
                _pulseFlags |= PulseFlags.Plugins;
            }

            RegisterHotkeys();
            GlobalSettings.Instance.LogoutForInactivity = false;

            // Get all HB's default handlers for navigation
            _prevStuckHandler = Navigator.NavigationProvider.StuckHandler;
            _prePlayerMoverHandler = Navigator.PlayerMover;
            _preNavigationProvider = Navigator.NavigationProvider;

            SetNavigationSystem();

            // do someth
        }

        


        public override void Stop()
        {
            TreeRoot.TicksPerSecond = _oldTps;
            //_isInitialized = false;

            QuestingAndInteraction.DetatchQuestingEvents();

            Lua.Events.DetachEvent("START_LOOT_ROLL", HandleLootRoll);
            Lua.Events.DetachEvent("CONFIRM_LOOT_ROLL", HandleConfirmLootRoll);
            Lua.Events.DetachEvent("CONFIRM_DISENCHANT_ROLL", HandleConfirmLootRoll);

            Lua.Events.DetachEvent("LFG_ROLE_CHECK_SHOW", OnLfgRoleCheck);
            Lua.Events.DetachEvent("LFG_PROPOSAL_SHOW", OnLfgProposalShow);
            Lua.Events.DetachEvent("RESURRECT_REQUEST", OnRecurrectionHandler);
            Lua.Events.DetachEvent("READY_CHECK", OnReadyCheckHandler);
            Lua.Events.DetachEvent("PARTY_MEMBERS_CHANGED", HandlePartyMembersChanged);

            BotEvents.Player.OnMapChanged -= Player_OnMapChanged;
            

            Log.Info("Unregistering chat commands");
            Chat.Say -= NewCommand;
            Chat.Whisper -= NewCommand;
            Chat.Party -= NewCommand;
            Chat.Raid -= NewCommand;
            
            //Lua.Events.DetachEvent("CHAT_MSG_PARTY", Handler);
            //Lua.Events.DetachEvent("CHAT_MSG_SAY", Handler);
            //Lua.Events.DetachEvent("CHAT_MSG_WHISPER", Handler);
            //Lua.Events.DetachEvent("CHAT_MSG_RAID", Handler);

            GlobalSettings.Instance.LogoutForInactivity = true;
            UnregisterHotkeys();

            RestoreNavigationSystem();

        }

        private static int ResultNumber(String settingName)
        {
            int result;

            string numFromString = Regex.Match(settingName, @"\d+").Value;
            return Int32.TryParse(numFromString, out result) ? result : 0;
        }

        public override void Initialize()
        {
            Setting.Instance.Load();
            ProfileManager.LoadEmpty();
            //_isInitialized = false;

            Log.InitLog(Name + " [" + _version + "]");
            
            
            base.Initialize();
        }
        #endregion

        #region Navigation System set and restore

        public static void SetNavigationSystem()
        {
            if (Setting.Instance.AdvancedNavigationSystem.Contains("CTM"))
            {
                Log.Info("Overriding default HB navigation providers...");

                Navigator.PlayerMover = new CTMPlayerMovement();
                Navigator.NavigationProvider = new CTMNavigation();
            }

            if (Setting.Instance.AdvancedStuckHandler.OK())
            {
                Navigator.NavigationProvider.StuckHandler = _prevStuckHandler;
            }
            else
            {
                Log.Info("Disabling navigation 'stuck' provider...");
                Navigator.NavigationProvider.StuckHandler = pNoStuckHandling;
            }
        }

        public static void RestoreNavigationSystem()
        {
            // Restore the default HB navigation handlers
            Log.Info("Restoring default HB navigation providers...");
            Navigator.NavigationProvider.StuckHandler = _prevStuckHandler;
            Navigator.PlayerMover = _prePlayerMoverHandler;
            Navigator.NavigationProvider = _preNavigationProvider;

        }

        #endregion


        #region Lock Selector
        // perform all the parsed logic within a frame lock
        /*
        private class LockSelector : PrioritySelector
        {
            public LockSelector(params Composite[] children) : base(children){}

            public override RunStatus Tick(object context)
            {
                using (StyxWoW.Memory.AcquireFrame())
                {

                    try
                    {
                        return base.Tick(context);
                    }
                    catch (Exception e)
                    {
                        Console.WriteLine(e);
                    }
                }

                return RunStatus.Failure;
            }
        }
        */

        #endregion

        #region Various event handlers

        /// <summary> Handles the 'CONFIRM_LOOT_ROLL' and 'CONFIRM_DISENCHANT_ROLL' event. Fires when you try to roll "need" or "greed" for an item which Binds on Pickup. </summary>
        private void HandleConfirmLootRoll(object sender, LuaEventArgs e)
        {
            if (Setting.Instance.LootRolling.Contains("Ignore")) return;

            double rollId = (double)e.Args[0];
            double rollType = (double)e.Args[1];

            Lua.DoString("ConfirmLootRoll({0},{1})", rollId, rollType);
        }

        private void HandleLootRoll(object sender, LuaEventArgs e)
        {
            if (Setting.Instance.LootRolling.Contains("Ignore")) return;

            string rollId = e.Args[0].ToString();

            switch (Setting.Instance.LootRolling)
            {
                case "Greed":
                    Log.Info("Rolling GREED on loot");
                    Lua.DoString(string.Format("RollOnLoot({0}, 2)", rollId));
                    break;

                case "Need":
                    Log.Info("Rolling NEED on loot");
                    Lua.DoString(string.Format("RollOnLoot({0}, 1)", rollId));
                    break;

                case "Disenchant":
                    Log.Info("Rolling DISENCHANT on loot");
                    bool canDisenchant = Lua.GetReturnVal<bool>(string.Format("return GetLootRollItemInfo({0})", rollId), 7);
                    if (canDisenchant)
                    {
                        Lua.DoString(string.Format("RollOnLoot({0}, 3)", rollId));
                    }
                    else
                    {
                        Log.Info("Unable to roll Disenchant on the loot, rolling Greed");
                        Lua.DoString(string.Format("RollOnLoot({0}, 2)", rollId));
                    }
                    break;

                case "Pass":
                    Log.Info("Rolling PASS on loot");
                    Lua.DoString(string.Format("RollOnLoot({0}, 0)", rollId));
                    break;

            }


        }


        private void OnPartyInvite(object sender, LuaEventArgs args)
        {
            if (Leader != null)
            {
                string inviteFrom = args.Args[0].ToString();
                
                if (Leader.Name == inviteFrom)
                {
                    Log.Info(string.Format("Accepting group invite from {0}", inviteFrom));
                    Lua.DoString("RunMacroText(\"/click StaticPopup1Button1\")");
                }

            }
        }


        private void OnReadyCheckHandler(object sender, LuaEventArgs args)
        {
            if (Setting.Instance.AutomationReadyCheck.OK())
            {
                Log.Info("Ready check has been initiated by " + args.Args[0]);
                Lua.DoString("RunMacroText(\"/click ReadyCheckFrameYesButton\")");
            }
        }

        private void OnRecurrectionHandler(object sender, LuaEventArgs args)
        {

            if (Setting.Instance.AutomationRecurrection.OK())
            {
                Log.Info("Resurrection has been cast on you");
                Lua.DoString("RunMacroText(\"/click StaticPopup1Button1\")");
            }


        }

        public static void OnLfgProposalShow(object obj, LuaEventArgs args)
        {
            Log.Info("OnLfgProposalShow .... ");
            Lua.DoString("AcceptProposal()");
        }

        public static void OnLfgRoleCheck(object obj, LuaEventArgs args)
        {
            Log.Info("OnLfgRoleCheck .... ");
            Lua.DoString("CompleteLFGRoleCheck(true)");
        }

        private void HandlePartyMembersChanged(object sender, LuaEventArgs args)
        {
            FollowTheLeader.Leader = null;
        }

        private void Player_OnMapChanged(BotEvents.Player.MapChangedEventArgs args)
        {
            _root = null;
        }
        #endregion

        #region Chat Commands

        
        private static void NewCommand(Chat.ChatLanguageSpecificEventArgs e)
        {
            if (Leader == null) return;
            //if (e.Author != null) return;

            // make this character the new leader
            string[] newLeaderCommand = Setting.Instance.ChatMakeLeader.Split('|');
            foreach (string s in newLeaderCommand.Where(s => e.Message.ToUpper() == s.ToUpper().Trim()))
            {
                if (e.Author == null) continue;

                Setting.Instance.FollowLeader = e.Author;

                if (Me.Name != Setting.Instance.FollowLeader)
                {
                    Log.Info("The new leader has been set to " + Setting.Instance.FollowLeader);
                    WoWUnit temp = Leader;
                }
                else
                {
                    Setting.Instance.FollowLeader = "[None]";
                }
            }


            if (e.Author != Leader.Name) return;

            bool validCommand = false;

            // don't follow
            string[] nofollowCommands = Setting.Instance.ChatNoFollowCommand.Split('|');
            foreach (string s in nofollowCommands.Where(s => e.Message.ToUpper() == s.ToUpper().Trim()))
            {
                FollowTheLeader.FollowLeaderName = Setting.Instance.FollowLeader;
                FollowTheLeader.WaitingHere = true;
                Log.Info("Not following leader. You *MUST* type the follow command to re-enable this");
            }

            // slash follow 
            string[] justfollowCommands = Setting.Instance.ChatSlashFollowCommand.Split('|');
            foreach (string s in justfollowCommands.Where(s => e.Message.ToUpper() == s.ToUpper().Trim()))
            {
                FollowTheLeader.FollowLeaderName = Setting.Instance.FollowLeader;
                Lua.DoString(string.Format("RunMacroText(\"/follow {0} \")", Behaviors.FollowTheLeader.FollowLeaderName));
                //WaitingHere = true;
                //Log.Info("Not following leader. You *MUST* type the follow command to re-enable this");
            }

            // follow me
            string [] followCommands = Setting.Instance.ChatFollowCommand.Split('|');
            foreach (string s in followCommands.Where(s => e.Message.ToUpper() == s.ToUpper().Trim()))
            {
                FollowTheLeader.WaitingHere = false;
                Setting.Instance.FollowLeader = Behaviors.FollowTheLeader.FollowLeaderName;
                Log.Info("Following leader");
                validCommand = true;
            }
            
            // turn off looting
            string[] nolootCommands = Setting.Instance.ChatNoLootCommand.Split('|');
            foreach (string s in nolootCommands.Where(s => e.Message.ToUpper() == s.ToUpper().Trim()))
            {
                Setting.Instance.Loot = "Never";
                Log.Info("Looting disabled");
                validCommand = true;
            }

            // turn on looting
            string[] lootCommands = Setting.Instance.ChatLootCommand.Split('|');
            foreach (string s in lootCommands.Where(s => e.Message.ToUpper() == s.ToUpper().Trim()))
            {
                Setting.Instance.Loot = "Always";
                Log.Info("Looting enabled");
                validCommand = true;
            }

            //todo add combat follow enable and disable

            // force assist me
            string[] assistCommands = Setting.Instance.ChatAssistCommand.Split('|');
            foreach (string s in assistCommands.Where(s => e.Message.ToUpper() == s.ToUpper().Trim()))
            {
                if (Leader != null && Leader.GotTarget)
                {
                    Leader.CurrentTarget.Target();
                    Log.Info("Assisting leader and targeting " + Leader.CurrentTarget.Name);
                }
            }

            // combat follow
            string[] combatFollowCommands = Setting.Instance.ChatCombatFollowCommand.Split('|');
            foreach (string s in combatFollowCommands.Where(s => e.Message.ToUpper() == s.ToUpper().Trim()))
            {
                Setting.Instance.CombatFollow = "Always";
                Log.Info("Combat follow enabled");
                validCommand = true;
            }

            // no combat follow
            string[] nocombatFollowCommands = Setting.Instance.ChatNoCombatFollowCommand.Split('|');
            foreach (string s in nocombatFollowCommands.Where(s => e.Message.ToUpper() == s.ToUpper().Trim()))
            {
                Setting.Instance.CombatFollow = "Never";
                Log.Info("Combat follow disabled");
                validCommand = true;
            }

            // no combat follow
            string[] movehereCommands = Setting.Instance.ChatMoveHereCommand.Split('|');
            foreach (string s in movehereCommands.Where(s => e.Message.ToUpper() == s.ToUpper().Trim()))
            {
                if (Leader != null)
                {
                    Log.Info("Moving to leaders position");
                    Navigator.MoveTo(Leader.WorldLocation);

                    /*
                    while (Me.IsMoving)
                    {
                        Thread.Sleep(500);
                        ObjectManager.Update();
                    }
                     */
                }
            }


            // interact with this
            string[] clickThisCommands = Setting.Instance.ChatClickThisCommand.Split('|');
            foreach (string s in clickThisCommands.Where(s => e.Message.ToUpper().Contains(s.ToUpper().Trim())))
            {
                //Log.InitLog("--- step 2" + s);
                if (Leader != null)
                {
                    string partialName = e.Message.Replace(s, "").Trim().ToUpper();

                    WoWObject gameObject = ObjectManager.GetObjectsOfTypeFast<WoWObject>().Where(o => o.Name.ToUpper().Contains(partialName)).OrderBy(o => o.WorldLocation.Distance(Leader.WorldLocation)).FirstOrDefault();

                    if (gameObject != null)
                    {
                        // yeah yeah yeah, we're using thread.sleep. I know its REALLY bad
                        Log.DebugLog("Moving to interact with " + gameObject.Name);

                        if (!gameObject.WithinInteractRange)
                        {
                            Navigator.MoveTo(WoWMovement.CalculatePointFrom(gameObject.WorldLocation, (float) 0.70*gameObject.InteractRange));
                            //Navigator.MoveTo(gameObject.WorldLocation);
                            Thread.Sleep(500);
                            ObjectManager.Update();
                        }

                        while (Me.IsMoving)
                        {
                            Thread.Sleep(250);
                            ObjectManager.Update();
                            if (!gameObject.WithinInteractRange) continue;

                            StopMoving.Now();
                            break;
                        }

                        if (Me.IsMoving)
                        {
                            StopMoving.Now();
                            Thread.Sleep(1000);
                        }
                        Log.Info("Interacting with " + gameObject.Name);
                        gameObject.Interact();
                    }
                    else
                    {
                        Log.DebugLog("We're inside the Click This command but no object was found that matches the description");
                    }
                }
            }


            // use inventory item
            string[] inventoryItemCommands = Setting.Instance.ChatInventoryItemCommand.Split('|');
            foreach (string s in inventoryItemCommands.Where(s => e.Message.ToUpper().Contains(s.ToUpper().Trim())))
            {
                string partialName = e.Message.Replace(s, "").Trim().ToUpper();

                Log.DebugLog("Use item " + partialName);
                
                foreach (WoWItem item in Me.Inventory.Items)
                {
                    try
                    {
                        //Log.Info("... found " + item.Name);
                        if (item.Name.ToUpper().Contains(partialName))
                        {
                            Log.Info(string.Format("Attempting to use inventory item '{0}'", item.Name));
                            item.Use();
                            break;
                        }
                        {
                            Log.Info(string.Format("No inventory item found matching '{0}'", partialName));
                        }
                    }
                    catch (Exception exception) { Log.DebugLog("Exception finding and using inventory item: " + exception.Message); }
                }

                /*
                if (item != null)
                {
                    Log.Info("Using inventory item " + item.Name);
                    item.Interact();
                }
                 */
                
            }

            // follow distance
            string[] followDistanceCommands = Setting.Instance.ChatFollowDistanceCommand.Split('|');
            foreach (string s in followDistanceCommands.Where(s => e.Message.ToUpper() == s.ToUpper().Trim()))
            {
                int followDistance = ResultNumber(e.Message);

                if (followDistance <= 0)
                {
                    Log.Info("A follow distance of 1 or more must be used");
                    return;
                }

                Setting.Instance.FollowDistance = followDistance;
                Log.Info("Following distance set to " + Setting.Instance.FollowDistance);
                validCommand = true;
            }


            if (Me.Class == WoWClass.Hunter)
            {
                if (e.Message == "aop" || e.Message == "pack")
                {
                    Log.Info("Casting Aspect of the Pack");
                    SpellManager.Cast("Aspect of the Pack");
                }

                if (e.Message == "aoh" || e.Message == "aoth" || e.Message == "hawk")
                {
                    Log.Info("Casting Aspect of the Hawk");
                    SpellManager.Cast("Aspect of the Hawk");
                }
            }

            if (validCommand) Setting.Instance.Save();
        }
        #endregion

        #region Hotkeys

        public static Keys KeyBinding(string setting)
        {
            if (setting.Contains("None")) return Keys.None;

            if (Enum.IsDefined(typeof (Keys), setting))
            {
                return (Keys) Enum.Parse(typeof (Keys), setting);
            }

            // If all else fails just reutrn None
            return Keys.None;
        }

         private static ModifierKeys KeyBindingModifier(string setting)
        {
            if (setting.Contains("None") || setting.Contains("NoRepeat")) return ModifierKeys.NoRepeat;

            if (Enum.IsDefined(typeof (ModifierKeys), setting))
            {
                return (ModifierKeys) Enum.Parse(typeof (ModifierKeys), setting);
            }


            // If all else fails just reutrn None
            return ModifierKeys.NoRepeat;
        }

        protected void UnregisterHotkeys()
        {
            Log.InitLog("Unregistering all hotkeys");
            HotkeysManager.Unregister("FCB Movement Toggle");
            HotkeysManager.Unregister("FCB Pause Toggle");
            HotkeysManager.Unregister("FCB Looting Toggle");
            HotkeysManager.Unregister("FCB Assist Me");
        }

        protected void RegisterHotkeys()
        {
            Log.InitLog("Registering hotkeys");
            Log.InitLog(" ");
            Log.InitLog("Movement toggle, Key:" + Setting.Instance.KeyMoveToTarget + " Mod: " + Setting.Instance.KeyMoveToTargetMod);
            Log.InitLog("Combat Bot toggle, Key:" + Setting.Instance.KeyPauseBotbase + " Mod: " + Setting.Instance.KeyPauseBotbaseMod);
            Log.InitLog("Looting toggle, Key:" + Setting.Instance.KeyLooting + " Mod: " + Setting.Instance.KeyLootingMod);
            Log.InitLog("Assist Me, Key:" + Setting.Instance.KeyAssist + " Mod: " + Setting.Instance.KeyAssistMod);
            Log.InitLog("Object Interaction toggle, Key:" + Setting.Instance.KeyObjectInteraction + " Mod: " + Setting.Instance.KeyObjectInteractionMod);
            
            HotkeysManager.Register("FCB Movement Toggle", KeyBinding(Setting.Instance.KeyMoveToTarget), KeyBindingModifier(Setting.Instance.KeyMoveToTargetMod), MovementToggle);
            HotkeysManager.Register("FCB Pause Toggle", KeyBinding(Setting.Instance.KeyPauseBotbase), KeyBindingModifier(Setting.Instance.KeyPauseBotbaseMod), PauseBotBase);
            HotkeysManager.Register("FCB Looting Toggle", KeyBinding(Setting.Instance.KeyLooting), KeyBindingModifier(Setting.Instance.KeyLootingMod), LootingToggle);
            HotkeysManager.Register("FCB Assist Me", KeyBinding(Setting.Instance.KeyAssist), KeyBindingModifier(Setting.Instance.KeyAssistMod), ForceAssistMe);
            HotkeysManager.Register("FCB Combat Follow", KeyBinding(Setting.Instance.KeyCombatFollow), KeyBindingModifier(Setting.Instance.KeyCombatFollowMod), CombatFollow);
            HotkeysManager.Register("FCB Object Interaction", KeyBinding(Setting.Instance.KeyObjectInteraction), KeyBindingModifier(Setting.Instance.KeyObjectInteractionMod), ObjectInteraction);
        }

        private void PauseBotBase(Hotkey obj)
        {
            PauseBotbase = !PauseBotbase;

            Lua.DoString(PauseBotbase
                             ? @"print('FCBot \124cFFE61515 PAUSED!')"
                             : @"print('FCBot \124cFF15E61C ENABLED!')");
        }

        private void ObjectInteraction(Hotkey obj)
        {
            switch (Setting.Instance.QuestObjectInteract)
            {
                case "Automatically":
                    Setting.Instance.QuestObjectInteract = "Ignore";
                    Lua.DoString(@"print('FCB Object Interaction \124cFFE61515 DISABLED!')");
                    break;

                case "Ignore":
                    Setting.Instance.QuestObjectInteract = "Automatically";
                    Lua.DoString(@"print('FCB Object Interaction \124cFF15E61C ENABLED!')");
                    break;
            }
        }

        private void CombatFollow(Hotkey obj)
        {
            switch (Setting.Instance.CombatFollow)
            {
                case "Always":
                    Setting.Instance.CombatFollow = "Never";
                    Lua.DoString(@"print('FCB Combat Following \124cFFE61515 DISABLED!')");
                    break;

                case "Never":
                    Setting.Instance.CombatFollow = "Always";
                    Lua.DoString(@"print('FCB Combat Following \124cFF15E61C ENABLED!')");
                    break;
            }
        }

        private void LootingToggle(Hotkey obj)
        {
            switch (Setting.Instance.Loot)
            {
                case "Always":
                    Setting.Instance.Loot = "Never";
                    Lua.DoString(@"print('FCBot Looting \124cFFE61515 DISABLED!')");
                    break;

                case "Never":
                    Setting.Instance.Loot = "Always";
                    Lua.DoString(@"print('FCBot Looting \124cFF15E61C ENABLED!')");
                    break;
            }
        }

        private void ForceAssistMe(Hotkey obj)
        {
            if (Leader != null && Leader.GotTarget)
            {
                Leader.CurrentTarget.Target();
                Log.Info("Assisting leader and targeting " + Leader.CurrentTarget.Name);
            }
        }

        private static void MovementToggle(Hotkey obj)
        {
            switch (Setting.Instance.MoveToTarget)
            {
                case "Always":
                    Setting.Instance.MoveToTarget = "Never";
                    Lua.DoString(@"print('FCBot Movement \124cFFE61515 DISABLED!')");
                    break;

                case "Never":
                    Setting.Instance.MoveToTarget = "Always";
                    Lua.DoString(@"print('FCBot Movement \124cFF15E61C ENABLED!')");
                    break;
            }
        }

        #endregion
    }


}
