﻿using System.ComponentModel;
using System.Windows.Forms;

namespace LazyBoxer.UI
{
    public partial class UcInfoPanel : UserControl
    {
        public UcInfoPanel()
        {
            InitializeComponent();
        }

        [Category("Data")]
        [Description("Gets or sets the heading of this control")]
        [DefaultValue("Heading")]
        public string Heading
        {
            get { return labelHeading.Text; }
            set { labelHeading.Text = value; }
        }

        [Category("Data")]
        [Description("Gets or sets the body message of this control")]
        [DefaultValue("")]
        public string BodyMessage
        {
            get { return labelBody.Text; }
            set { labelBody.Text = value; }
        }

        [Category("Data")]
        [Description("Gets or sets the heading of this control")]
        [DefaultValue(true)]
        public bool HeadingVisible
        {
            get { return labelHeading.Visible; }
            set { labelHeading.Visible = value; }
        }

        [Category("Data")]
        [Description("Gets or sets the heading of this control")]
        [DefaultValue(true)]
        public new BorderStyle BorderStyle
        {
            get { return panel1.BorderStyle; }
            set { panel1.BorderStyle = value; }
        }


    }
}
